// Hint: This file is for styling the backend form widget from the entity reference layout module.
//       It's not used in the frontend.

// Copied variables from admin-variables.css (drowl_admin module) to have vscode autocompletion, what even works if commented out - but not simply across files -_-
// :root{
//   /* Brand variables */
//   --drowl-green: #89a129;
//   --drowl-text-color: #342e37;
//   --drowl-green-text-color: #fff;
//   --drowl-border-radius-small: 3px;
//   /* Adminimal Theme colors */
//   --adminimal-primary: #327ebd;
//   --adminimal-primary-light: #8abbe4;
//   --adminimal-grey-light: #dbdbdb;
//   /* Spaces */
//   --drowl-space-md: 1rem;
//   /* Typo */
//   --drowl-font-family: "Open Sans", Arial, sans-serif; /* Font family used by admin toolbar, what should be available everywhere we need it too. */
//   --drowl-font-size-base: 16px;
//   --drowl-font-size-small: 14px;
//   --drowl-font-weight-bold: 600;
//   /* Colors */
//   --drowl-gray-light: #eeeeee;
//   --drowl-gray-medium: #cccccc;
//   --drowl-white-glass: rgba(255,255,255,.65);
//   --drowl-black-glass: rgba(0,0,0,.75);
//   /* Status colors (https://coolors.co/3c91e6-342e37-e5ece6-a2d729-fa824c) */
//   --drowl-success: #a2d729;
//   --drowl-success-light: #eef7d8;
//   --drowl-success-text: #fff;
//   --drowl-warning: #fd6d2a;
//   --drowl-warning-light: #fee8de;
//   --drowl-warning-text: #fff;
//   --drowl-info: #3c91e6;
//   --drowl-info-light: #dbebfa;
//   --drowl-info-transparent: rgba(60,145,230,.5);
//   --drowl-info-text: #fff;
//   /* Objects */
//   /* -- Buttons */
//   --drowl-button-border-radius: var(--drowl-border-radius-small);
//   --drowl-button-padding: 8px 15px;
//   --drowl-button-default-background: var(--drowl-info);
//   --drowl-button-default-color: var(--drowl-info-text);
//   --drowl-button-text-shadow: 1px 1px 1px rgba(0,0,0,.25);
//   /* Editors */
//   --drowl-editor-border-radius-small: var(--drowl-border-radius-small);
//   --drowl-editor-grid-gutter: 8px;
// }

@import './scss/_configuration/settings';

// Custom mixins
@import './scss/_mixins/mixins';

// Styles
@include foundation-typography;
@include foundation-responsive-embed;
@import './frontend_libraries/webksdct-base/scss/base/colors';
@import './frontend_libraries/webksdct-base/scss/base/spacings_responsive';
@import './scss/components/icons';
@import './scss/components/box_styles';
@import './scss/components/list_styles';
@import './scss/components/slider';
@import './scss/components/cards';
@import './scss/components/media_objects';
@import './scss/entities/media';

// Editor styles
.field--widget-layout-paragraphs{
  // ===================================
  // Wrappers / Container
  // ===================================
  fieldset.layout-paragraphs-field{
    background:white !important;
    border:1px solid var(--adminimal-grey-light);
    // Remove drupal cores button gradients
    .button:not([class*="layout-paragraphs-"]){
      background-image:none;
    }
  }
  .layout-paragraphs-layout{
    border: 1px solid transparent;
    box-shadow:0 1px 3px rgba(0,0,0,.1);
    transition-duration:150ms;
    transition-property: border-color, padding, margin, box-shadow;
    &:hover{
      // border-color:rgba(0,0,0,.1);
      box-shadow:0 0 6px rgba(0,0,0,.2);
      // TODO: This :hover layout changes are kinda disturbing.. remove em
      // padding-left:5px;
      // padding-right:5px;
      // margin-left:-5px;
      // margin-right:-5px;
    }
    &::before{
      background-color:transparent;
      border-bottom:1px dotted #ccc;
      top:20px;
    }
  }
  .layout-paragraphs-layout-region{
    padding: var(--drowl-editor-grid-gutter);
    .layout-paragraphs-item{
      border:1px solid var(--drowl-gray-light);
      padding-left:var(--drowl-editor-grid-gutter);
      padding-right:var(--drowl-editor-grid-gutter);
      // Reserved space for the buttons
      padding-top:42px;
      // Fix add button position in this context
      .layout-paragraphs-add-content__toggle{
        // Ensure the button does not cover the other buttons here
        max-width:33%;
      }
    }
    // -- Add button styles and override cores seven button styles
    @include foundation-button;
  }

  // Layout Paragraphs
  .paragraph--type-layout{
    // Backend Labels
    > .field--name-field-title{
      text-align:center;
      font-size: var(--drowl-font-size-small);
      font-weight: bold;
      display:flex;
      justify-content:center;
      margin-top:-1.15rem;
      position:relative;
      pointer-events:none;
      *{
        font-size:inherit !important;
        font-weight:inherit !important;
        background:white;
        padding:.25rem;
      }
    }
  }

  // ===================================
  // All control widgets (layout containers and single paragraphs)
  // ===================================

  // -- Dont hide layout section controls while not hovered
  .layout-controls,
  .layout-paragraphs-actions,
  .gu-mirror .layout-paragraphs-actions{
    visibility: visible;
    opacity:1;
    > input{
      opacity:1 !important;
    }
  }

  .layout-paragraphs-item{
    > .layout-controls,
    > .layout-paragraphs-actions{
      top:5px !important;
      z-index:2;
      background: transparent;
      // box-shadow: 0 0 2px 2px white; why? looks very ugly on darker backgrounds - add solid white bg color also if this is needed.
      display:flex;
      width:auto !important;
      .layout-handle{
        order:-1;
      }
    }
    > .layout-controls{
      left: var(--drowl-editor-grid-gutter) !important;
    }
    > .layout-paragraphs-actions{
      right: var(--drowl-editor-grid-gutter) !important;
    }
    > .layout-controls > div,
    > .layout-paragraphs-actions > input{
      // Control buttons
      position:static !important;
      opacity:1;
      background-color: $white !important;
      box-shadow: 0 0 1px rgba(0,0,0,.1) !important;
      border-radius:3px;
      margin-left:2px !important;
      margin-right:2px !important;
      width:34px !important;
      flex:0 0 34px !important;
      transition-duration:80ms;
      transition-property: transform, opacity;
      &:hover{
        box-shadow: 0 1px 1px rgba(0,0,0,.2) !important;
        background-color: $white !important;
      }
    }
    // Shrink control buttons while not hovered
    &:not(:hover){
      > .layout-controls > div,
      > .layout-paragraphs-actions input{
        transform: scale(.5);
        opacity:0 !important;
      }
    }
    // While dragging
    // TODO: not working buttons still visible
    &.gu-transit{
      // Hide actions while dragging, they got ugly buttons style in this state for some reason
      > .layout-paragraphs-actions{
        visibility:hidden !important;
      }
    }
    // Fix ZF vertical grid (otherwise the contents overlapping the wrapper)
    .grid-margin-y{
      margin-top:0;
      margin-bottom:0;
    }
  }
  // ===================================
  // Layout control widget
  // ===================================
  .layout-paragraphs-layout.layout-paragraphs-item{
    &::before{
      background-color: transparent;
      border-bottom: 1px dotted #ccc;
      top: 20px;
    }
    // > .layout-controls,
    // > .erl-actions{

    // }
  }

  // Layout Paragraphs: Layout selection
  .layout-select.form-radios{
    display:grid;
    grid-gap: .75rem;
    grid-template-columns: repeat(auto-fit, minmax(180px, 1fr));
    > .form-item{
      margin:0;
      label{
        box-sizing:border-box;
        width:100%;
        margin:0;
      }
    }
    input:checked + label{
      border-color: var(--drowl-green);
      outline: 2px solid var(--drowl-green);
    }
    input:hover + label{
      border-color: var(--drowl-green);
    }
  }

  // Layout Preview SVGs coloring
  // TODO: Shouldn't this live in the drowl_layouts module?
  .layout-icon[class*="drowl"]{
    .layout-icon__region{
      fill: white !important;
      stroke: var(--drowl-green) !important;
    }
  }


  // ===================================
  // Paragraph control widget
  // ===================================
  // .layout-paragraphs-layout-region .layout-paragraphs-item{
    // TODO: Remove? This class is no longer present for layout-paragraphs (also no .layout-paragraphs-add-content)
    // button.erl-add-content{
    //   opacity:.75;
    //   filter: grayscale(1);
    //   transition-property: opacity, filter;
    // }
  //   &:hover{
  //     border-color: var(--adminimal-primary);
  //     button.erl-add-content{
  //       filter: grayscale(0);
  //     }
  //   }
  // }

  // ===================================
  // Add Layout Button
  // ===================================

  // TODO: Remove? This class is no longer present for layout-paragraphs (also no .layout-paragraphs-add-content--single)
  // .erl-add-content--single{
  //   position:static;
  //   margin: .5rem auto;
  //   width:auto;
  //   display:flex;
  //   justify-content:center;
  //   opacity:1; // always show the layout add button
  //   > button{
  //     background: var(--drowl-green) !important;
  //     color: var(--drowl-green-text-color) !important;
  //     text-shadow:1px 1px 1px rgba(0,0,0,.25);
  //     border-radius: var(--drowl-border-radius-small);
  //     display:flex;
  //     align-items:center;
  //     justify-content: center;
  //     text-decoration: none;
  //     line-height:1.1;
  //     padding: .75em;
  //     text-align:left;
  //     white-space: nowrap;
  //     overflow: hidden !important;
  //     text-overflow: ellipsis;
  //     position:relative;
  //     width:auto;
  //     > .icon{
  //       text-indent:0;
  //       position:absolute;
  //       left:0;
  //       top:0;
  //       display:block;
  //       width:10px;
  //       height:10px;
  //       display:block;
  //       border-radius: 0 0 50% 0;
  //       background: white;
  //       text-align: center;
  //       font-size:10px;
  //       line-height:10px;
  //       vertical-align: middle;
  //       text-shadow:none;
  //       color: var(--drowl-text-color) !important;
  //     }
  //     > img{
  //       flex: 0 0 60px;
  //     }
  //     &:hover{
  //       text-decoration:none !important;
  //       filter: brightness(1.1);
  //     }
  //   }
  // }
}

// ===================================
// Add Paragraph dropdown menu
// ===================================

// TODO: this button, especialy its position needs to be improved
.layout-paragraphs-add-content__toggle{
  position: absolute;
  opacity:1;
  width: auto;
  border-radius: 0 0 4px 4px;
  padding: .85em;
  background: var(--adminimal-primary);
  display: block;
  height: 30px !important;
  margin-top:0;
  margin-bottom:0;
  margin-left: auto;
  margin-right: auto;
  align-items: center;
  white-space: nowrap;
  overflow:hidden;
  text-overflow:ellipsis;
  justify-content: center;
  margin-left: 0;
  text-indent: 0;
  text-transform: uppercase;
  font-size: 10px;
  font-weight: bold;
  left: 50%;
  // Prevent the default transform rotate behavoir (also fix position)
  transform: translateX(-50%) !important;
  &:last-of-type{
    top:auto !important;
    bottom:0 !important;
    border-radius: 4px 4px 0 0;
  }
  &::after{
    content:"Absatz hinzufügen";
  }
}

// Dropdown flyout
.layout-paragraphs-add-more-menu{
  &.fade-in{
    display:flex;
  }
  flex-direction:column;
  width:300px;
  left: 50% !important;
  transform: translateX(-50%);
  @media only screen and (min-width: 680px){
    width:550px;
  }
}
// Re-enable links from option menus (other links inside the layout paragraphs preview should be disabled to prevent exiting the node form by accident)
.layout-paragraphs-add-more-menu,
.contextual{
  a{
    pointer-events:all !important;
  }
}
.layout-paragraphs-add-more-menu__group{
  flex: 1 0 auto;
  display:flex;
  flex-direction: column;
  max-height:500px;
  overflow-y: scroll;
  overflow-x: hidden;
  background-color: #fafbfd; // TODO: replace with css variable from drowl_admin
  .layout-paragraphs-add-more-menu__group--layout{
    flex: 0 0 auto;
    box-shadow: 0 0 5px rgba(0,0,0,.1);
  }
  .layout-paragraphs-add-more-menu__group--content{
    overflow:visible;
    flex: 1 0 auto;
    width:100%;
    @supports(display:grid){
      display:grid;
      grid-gap: 1px;
      grid-template-columns: 1fr 1fr;
      @media only screen and (min-width: 680px){
        grid-template-columns: repeat(4, 1fr);
      }
      .layout-paragraphs-add-more-menu__search{
        flex: 0 0 auto;
        grid-column: span 2;
        width:auto;
        z-index: 5;
        @media only screen and (min-width: 680px){
          grid-column: span 4;
        }
      }
      .layout-paragraphs-add-more-menu__item{
        flex-direction: column;
        font-size: .75rem; // TODO: replace with css variable from drowl_admin
        line-height:1.1;
        text-align:center;
        margin-bottom:0;
        width:auto;
        &:not([style*="none"]){
          display:flex !important;
        }
        img{
          height: auto;
          width: auto;
          box-shadow: 0 4px 4px -3px rgba(0,0,0,.1);
          transition-duration:80ms;
          transition-timing-function: cubic-bezier(.68,-0.55,.27,1.55);
          transition-property: transform;
          transform:scale(.9);
        }
        &:hover{
          img{
            transform:scale(1);
          }
        }
      }
    }
  }
}

// Horizontal layout for the Paragraphs add form inside modals / sub paragraphs (Select + Add Button + Parent referece field label)
.paragraphs-add-wrapper{
  display:flex;
  flex-flow: row wrap;
  align-items:flex-end;
  margin-left:0 !important;
  margin-right:0 !important;
  padding-left:0 !important;
  padding-right:0 !important;
  gap: .5rem;
  > *{
    margin:0 !important;
  }
}

// ===================================
// Bugfixes (contents / paragraph preview)
// ===================================
.layout-paragraphs-item{
  .paragraph{
    *{
      box-sizing:border-box;
    }
    // Ensure box styles with white text are still visible
    &.box-style--transparent-light{
      text-shadow: 1px 1px 1px rgba(0,0,0,.85);
    }
  }
  > .paragraph{
    // Prevent clicking links in preview content
    &:not(.paragraph--type-layout){
      a{
        pointer-events:none;
      }
    }
  }
  // -- Better Media video preview
  .media--type-video{
    position: relative;
    .field--type-video-embed-field{
      // Overlay video with the preview image
      + .field--type-image {
        pointer-events:none;
        position:absolute;
        bottom: 20px;
        right: 20px;
        width:30%;
        box-shadow: $shadow;
      }
    }
  }
  // Show fancy background image wrapper as a tiny preview-circle with the image in it
  // positioned left outside the paragraph preview
  // TODO: whats the benefit of this style? why not simply hav the background image behind the paragraphs (= frontend)
  > .fancy-background-image{
    position:relative;
    overflow:visible;
    // &::before{
    //   content:"";
    //   position:absolute;
    //   left:-55px;
    //   top:-8px;
    //   width:45px;
    //   height:45px;
    //   border-radius:50%;
    //   box-shadow: 0 1px 5px rgba(0,0,0,.2);
    //   border:2px solid white;
    //   z-index:1;
    // }
    // .fancy-background-image__img-wrapper{
    //   position:absolute;
    //   left:-55px;
    //   top:-8px;
    //   transform: none !important;
    //   width:45px;
    //   height:45px;
    //   border-radius:50%;
    //   background-attachment: scroll !important;
    //   background-size: cover !important;
    // }
  }
}

// Hide Paragraph type labels in draggable table fields
.draggable-table{
  .paragraph-type-label{
    display:none !important;
  }
}
